<?php

require_once ( 'config.php' );

// session indítása
session_name( SESSION_NAME );
session_start();

// "It is not safe to rely on the system's timezone settings..." strict error
date_default_timezone_set( DEFAULT_TIMEZONE );

/* __autoload magic függvény
    Osztályok betöltésére */
function __autoload( $class ){
	$class = strtolower( $class );
	if ( is_file( DIR_ROOT . "classes/$class.class.php" ) ) {
		require_once( DIR_ROOT . "classes/$class.class.php" );
	}  
	if ( is_file( DIR_ROOT . "modules/$class.php" ) ) {
		require_once( DIR_ROOT . "modules/$class.php" );
	} 
}

/* Kért oldal feldolgozása
     első paraméter => osztály név
     második paraméter => metódus név*/
$GLOBALS[ '__req' ] = explode("/", str_ireplace( URI_ROOT_DIR, "", $_SERVER[ 'REQUEST_URI'] ) );

foreach ( $GLOBALS[ '__req' ] as $key => $val ) {
	$GLOBALS[ '__req' ][ $key ] = urldecode( $val );
}

/* Ha nincs bejelentkezve a látogató,
    akkor átirányítás a bejelentkaző felületre */
$default_module = (isset($_SESSION['UserID'])) ? 'main' : 'login';

if ( strpos( @(string)$GLOBALS[ '__req' ][ 0 ], "." ) ) {
	$GLOBALS[ '__req' ][ 0 ] = $default_module;
}

// adott osztály nevének és létezésének ellenőrzése
if (! is_file( DIR_ROOT . "modules/" . @(string)$GLOBALS[ '__req' ][ 0 ] . "_module.php" ) )
{
	$GLOBALS[ '__req' ][ 0 ] = $default_module."_module";
} else {
	$GLOBALS[ '__req' ][ 0 ] .= "_module";
}

// adott metódus nevének és létezésének ellenőrzése
if ( @(string)$GLOBALS[ '__req' ][ 1 ] == "" ){
	$GLOBALS[ '__req' ][ 1 ] = "method_default";
} else {
	$GLOBALS[ '__req' ][ 1 ] = "method_" . $GLOBALS[ '__req' ][ 1 ];
}

/* Jogosultság ellenőrzés
    Ha nincs joga az adott mudolhoz, akkor átirányítás az alapértelmezett oldalra */
$str = $GLOBALS[ '__req' ][ 0 ]."/".$GLOBALS[ '__req' ][ 1 ];
if (in_array($str, $loggedin) && 
	(((!isset($_SESSION['UserID'])) || $_SESSION['UserID'] < 1)))
{
	$GLOBALS[ '__req' ][ 0 ] = $default_module."_module";
	$GLOBALS[ '__req' ][ 1 ] = "method_default";
}

// A modul és a benne levő akció meghívása
$GLOBALS[ '__module' ] = new $GLOBALS[ '__req' ][ 0 ]();
if ( method_exists( $GLOBALS[ '__module' ], $GLOBALS[ '__req' ][ 1 ] ) ){
	$GLOBALS[ '__module' ]->$GLOBALS[ '__req' ][ 1 ]();
}else{
	$GLOBALS[ '__module' ]->method_default();
}

?>